| OpenCV 5.0.0alpha Open Source Computer Vision

Loading...
Searching...
No Matches
Classes | Functions
Experimental 2D Features Algorithms
Extra 2D Features Framework

## Detailed Description

This section describes experimental algorithms for 2d feature detection.

## Classes
class | cv::xfeatures2d::AffineFeature2D
| Class implementing affine adaptation for key points. More...
class | cv::xfeatures2d::AgastFeatureDetector
| Wrapping class for feature detection using the AGAST method. : More...
class | cv::xfeatures2d::AKAZE
| Class implementing the AKAZE keypoint detector and descriptor extractor, described in [10]. More...
class | cv::xfeatures2d::BEBLID
| Class implementing BEBLID (Boosted Efficient Binary Local Image Descriptor), described in [257] . More...
class | cv::xfeatures2d::BoostDesc
| Class implementing BoostDesc (Learning Image Descriptors with Boosting), described in [262] and [263]. More...
class | cv::xfeatures2d::BriefDescriptorExtractor
| Class for computing BRIEF descriptors described in [47] . More...
class | cv::xfeatures2d::BRISK
| Class implementing the BRISK keypoint detector and descriptor extractor, described in [159] . More...
class | cv::xfeatures2d::DAISY
| Class implementing DAISY descriptor, described in [271]. More...
class | cv::xfeatures2d::Elliptic_KeyPoint
| Elliptic region around an interest point. More...
class | cv::xfeatures2d::FREAK
| Class implementing the FREAK (Fast Retina Keypoint) keypoint descriptor, described in [8] . More...
class | cv::xfeatures2d::HarrisLaplaceFeatureDetector
| Class implementing the Harris-Laplace feature detector as described in [193]. More...
class | cv::xfeatures2d::KAZE
| Class implementing the KAZE keypoint detector and descriptor extractor, described in [9] . More...
class | cv::xfeatures2d::LATCH
class | cv::xfeatures2d::LUCID
| Class implementing the locally uniform comparison image descriptor, described in [322]. More...
class | cv::xfeatures2d::MSDDetector
| Class implementing the MSD (Maximal Self-Dissimilarity) keypoint detector, described in [272]. More...
class | cv::xfeatures2d::PCTSignatures
| Class implementing PCT (position-color-texture) signature extraction as described in [152]. The algorithm is divided to a feature sampler and a clusterizer. Feature sampler produces samples at given set of coordinates. Clusterizer then produces clusters of these samples using k-means algorithm. Resulting set of clusters is the signature of the input image. More...
class | cv::xfeatures2d::PCTSignaturesSQFD
| Class implementing Signature Quadratic Form Distance (SQFD). More...
class | cv::xfeatures2d::StarDetector
| The class implements the keypoint detector introduced by [2], synonym of StarDetector. : More...
class | cv::xfeatures2d::TBMR
| Class implementing the Tree Based Morse Regions (TBMR) as described in [308] extended with scaled extraction ability. More...
class | cv::xfeatures2d::TEBLID
| Class implementing TEBLID (Triplet-based Efficient Binary Local Image Descriptor), described in [258]. More...
class | cv::xfeatures2d::VGG
| Class implementing VGG (Oxford Visual Geometry Group) descriptor trained end to end using "Descriptor Learning Using Convex Optimisation" (DLCO) aparatus described in [247]. More...

## Functions
void | cv::xfeatures2d::AGAST (InputArray image, std::vector< KeyPoint > &keypoints, int threshold, bool nonmaxSuppression=true, AgastFeatureDetector::DetectorType type=AgastFeatureDetector::OAST_9_16)
| Detects corners using the AGAST algorithm.
void | cv::xfeatures2d::FASTForPointSet (InputArray image, std::vector< KeyPoint > &keypoints, int threshold, bool nonmaxSuppression=true, cv::FastFeatureDetector::DetectorType type=FastFeatureDetector::TYPE_9_16)
| Estimates cornerness for prespecified KeyPoints using the FAST algorithm.

## Function Documentation

## ◆ AGAST()

void cv::xfeatures2d::AGAST | ( | InputArray | image,
|  | std::vector< KeyPoint > & | keypoints,
|  | int | threshold,
|  | bool | nonmaxSuppression = true,
|  | AgastFeatureDetector::DetectorType | type = AgastFeatureDetector::OAST_9_16 )

`#include <opencv2/xfeatures2d.hpp>`

Detects corners using the AGAST algorithm.

Parameters

  image | grayscale image where keypoints (corners) are detected.
  keypoints | keypoints detected on the image.
  threshold | threshold on difference between intensity of the central pixel and pixels of a circle around this pixel.
  nonmaxSuppression | if true, non-maximum suppression is applied to detected keypoints (corners).
  type | one of the four neighborhoods as defined in the paper: AgastFeatureDetector::AGAST_5_8, AgastFeatureDetector::AGAST_7_12d, AgastFeatureDetector::AGAST_7_12s, AgastFeatureDetector::OAST_9_16

For non-Intel platforms, there is a tree optimised variant of AGAST with same numerical results. The 32-bit binary tree tables were generated automatically from original code using perl script. The perl script and examples of tree generation are placed in features2d/doc folder. Detects corners using the AGAST algorithm by [180] .

## ◆ FASTForPointSet()

void cv::xfeatures2d::FASTForPointSet | ( | InputArray | image,
|  | std::vector< KeyPoint > & | keypoints,
|  | int | threshold,
|  | bool | nonmaxSuppression = true,
|  | cv::FastFeatureDetector::DetectorType | type = FastFeatureDetector::TYPE_9_16 )

`#include <opencv2/xfeatures2d.hpp>`

Estimates cornerness for prespecified KeyPoints using the FAST algorithm.

Parameters

  image | grayscale image where keypoints (corners) are detected.
  keypoints | keypoints which should be tested to fit the FAST criteria. Keypoints not being detected as corners are removed.
  threshold | threshold on difference between intensity of the central pixel and pixels of a circle around this pixel.
  nonmaxSuppression | if true, non-maximum suppression is applied to detected corners (keypoints).
  type | one of the three neighborhoods as defined in the paper: FastFeatureDetector::TYPE_9_16, FastFeatureDetector::TYPE_7_12, FastFeatureDetector::TYPE_5_8

Detects corners using the FAST algorithm by [229] .